﻿Public Class FrmManageItems

    Private SaveType = 0
    Private SelectedItemId = 0
    Private SelectedItemPrice = 0

    Public Sub EnableAllControls()
        TxtType.Enabled = True
        TxtName.Enabled = True
        TxtPrice.Enabled = True
        TxtDescription.Enabled = True
    End Sub

    Public Sub DisableAllControls()
        TxtType.Enabled = False
        TxtName.Enabled = False
        TxtPrice.Enabled = False
        TxtDescription.Enabled = False
    End Sub

    Public Sub GetCurrentRowData()
        SelectedItemId = DtgItems.CurrentRow.Cells("id").Value
        TxtType.Text = DtgItems.CurrentRow.Cells("Type").Value
        TxtName.Text = DtgItems.CurrentRow.Cells("Item name").Value
        TxtPrice.Text = DtgItems.CurrentRow.Cells("Price").Value
        TxtDescription.Text = DtgItems.CurrentRow.Cells("Description").Value
    End Sub

    Private Sub FrmManageItems_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Query(String.Format("SELECT id, `type` AS `Type`, `name` AS `Item name`, `price` AS `Price`, `description` AS `Description` FROM `items` WHERE user_id={0}", UserId), DtgItems)
        SetAutoCompletion("SELECT DISTINCT `type` FROM items", TxtType)
    End Sub

    Private Sub BtnSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnSave.Click
        If TxtType.Text = "" And TxtName.Text = "" And TxtPrice.Text = "" And TxtDescription.Text = "" Then
            MessageBox.Show("Please provide all the needed data.", PROGRAM_NAME, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        Else
            If SaveType = 0 Then
                Query("Added new item sucessfully.", String.Format("INSERT INTO `items`(`type`, `name`, `description`, `user_id`, `price`) VALUES ('{0}','{1}','{2}', '{3}', {4})", TxtType.Text, TxtName.Text, TxtDescription.Text, UserId, TxtPrice.Text))
            ElseIf SaveType = 1 Then
                Query("Updated an item sucessfully.", String.Format("UPDATE `items` SET `type`='{0}',`name`='{1}',`description`='{2}', `price`='{3}' WHERE id={4}", TxtType.Text, TxtName.Text, TxtDescription.Text, TxtPrice.Text, SelectedItemId))
            ElseIf SaveType = 2 Then
                Query("Updated price sucessfully.", String.Format("UPDATE `items` SET `price`='{0}' WHERE id={1}", TxtPrice.Text, SelectedItemId))

                'Save the current item price
                Query(String.Format("INSERT INTO `item_prices`(`item_id`, `user_id`, `price`) VALUES ({0},{1},{2})", SelectedItemId, UserId, SelectedItemPrice))
                'Save the new item price
                Query(String.Format("INSERT INTO `item_prices`(`item_id`, `user_id`, `price`) VALUES ({0},{1},{2})", SelectedItemId, UserId, TxtPrice.Text))
            End If

            BtnClearAll.PerformClick()
            FrmManageItems_Load(sender, e)
        End If
    End Sub

    Private Sub BtnClearAll_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnClearAll.Click
        SelectedItemPrice = 0
        SaveType = 0
        ClearInputs(GrpItemDetails)
        EnableAllControls()
    End Sub

    Private Sub BtnEditItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnEditItem.Click
        SaveType = 1

        GetCurrentRowData()

        EnableAllControls()
        TxtPrice.Enabled = False
    End Sub

    Private Sub BtnChangePrice_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnChangePrice.Click
        SaveType = 2

        SelectedItemPrice = DtgItems.CurrentRow.Cells("Price").Value
        TxtPrice.Text = SelectedItemPrice
        GetCurrentRowData()

        DisableAllControls()
        TxtPrice.Enabled = True
    End Sub

    Private Sub BtnViewPrice_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnViewPrice.Click
        FrmItemPrices.SelectedItemId = DtgItems.CurrentRow.Cells("id").Value
        FrmItemPrices.ShowDialog()
    End Sub

    Private Sub TxtPrice_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TxtPrice.KeyPress
        e.Handled = Not Char.IsNumber(e.KeyChar)
    End Sub

End Class